var GLOBAL_BASE_WEBSITE = 'https://www.asinseed.com';

function fGetCachedKey(station, asin) {
    var _cuser = JSON.parse(localStorage.getItem('CURRENT_ASINSEED_LOGIN_USER') || '{}');
    return station + "_" + asin + "_" + (_cuser.surname ? "L_" : "") + "_Cache_" + (new Date().getTime() / 1000 / 3600 / 24).toFixed(0)
}
function fGetToken() {
    var _cuser = JSON.parse(localStorage.getItem('CURRENT_ASINSEED_AUTH_USER') || '{}');
    return _cuser.token || "";
}

function fClearAllCache() {
    if (localStorage.length < 1000)return false;
    for (var i = localStorage.length - 1; i >= 0; i--) {
        localStorage.key(i).indexOf('CURRENT_ASINSEED_') < 0 && localStorage.removeItem(localStorage.key(i))
    }
}
function fClearResultCache() {
    for (var i = localStorage.length - 1; i >= 0; i--) {
        var _m = localStorage.key(i).match(/_([\d]{5,})$/), _v = (_m && _m[1]) || 999000999;
        (new Date().getTime() / 1000 / 3600 / 24).toFixed(0) > _v && localStorage.removeItem(localStorage.key(i))
    }
}

function fHasPageAsinList(asin, station) {
    if (asin == null || asin == '') return [];
    station = station || 'COM';

    var key = station + '_' + asin + '_list_' + (new Date().getTime() / 1000 / 3600 / 24).toFixed(0);
    var v = localStorage.getItem(key), data = v == null ? [] : JSON.parse(v);

    return v != null && v.length > 0;
}
function fGetPageAsinList(asin, station) {
    if (asin == null || asin == '') return [];
    station = station || 'COM';

    var key = station + '_' + asin + '_list_' + (new Date().getTime() / 1000 / 3600 / 24).toFixed(0);
    var v = localStorage.getItem(key), data = v == null ? [] : JSON.parse(v);
    for (var i = 0; i < data.length; i++)data[i]['text'] = data[i]['asin'] + ' ' + data[i]['title'];

    return data;
}

function fFormatDataDisplay(state) {
    if (state == null || state.asin == '')return '';

    var view = {
        asin: state.asin,
        title: state.title,
        img: state.img
    };
    return Mustache.to_html($('#id_tpl_script_list_asin_item').html(), view);
}

function fInitSelect2(asin, station) {
    var data = fGetPageAsinList(asin, station);
    if (data == null || data.length <= 1)return false;

    $('#head-form-asin').select2({
        placeholder: chrome.i18n.getMessage('module_gk_need_click_asin'),
        data: data,
        maximumInputLength: 10,
        containerCss: 'containerCss',
        containerCssClass: 'containerCssClass',
        dropdownCss: {position: 'fixed',left: 0,top: '40px',width: '688px !important',height: '470px'},
        dropdownCssClass: 'dropdownCssClass',
        templateResult: fFormatDataDisplay,
        language: {
            noResults: function () {
                return chrome.i18n.getMessage('module_gk_searching_list_item_with_no_results')
            }
        },
        templateSelection: function (r) {
            return r == null || r.asin == null || r.asin == '' ? chrome.i18n.getMessage('module_gk_need_click_asin') : r.asin;
        },
        escapeMarkup: function(m) { return m; }
    });
    SSTool.fIsBAsin(asin) && $('#head-form-asin').select2('val', '0');
    $('#head-form-asin').change(function () {
        var _id = $('#head-form-asin').val();
        _id < data.length && ($('#tab_gk').html($('#id_tpl_script_gk_data_loading').html()), fInitProductItems({
            station: station.toUpperCase(),
            asin: data[_id]['asin'].toUpperCase()
        }));
    });
}

function fIsNeedUpgrade(v) {
    v != null && v != '' && /^\d{1,2}\.\d\.\d{1,2}$/.test(v) && localStorage.setItem('ASINSEED_LATEST_VERSION', v);
    v = v || localStorage.getItem('ASINSEED_LATEST_VERSION');
    if (v == null || v == '' || !/^\d{1,2}\.\d\.\d{1,2}$/.test(v)) return false;

    return v > chrome.runtime.getManifest().version;
}

document.addEventListener('DOMContentLoaded', function() {
    // 国际化初始
    Mustache.parse($('body').html(), ['[[', ']]']);
    $('body').html(Mustache.to_html($('body').html(), chrome.i18n.getMessage));
    var _user = JSON.parse(localStorage.getItem('CURRENT_ASINSEED_AUTH_USER') || '{}'),
        _cuser = JSON.parse(localStorage.getItem('CURRENT_ASINSEED_LOGIN_USER') || '{}'),
        _f = Mustache.to_html($('#main-container .list-bottom').html(), {
            'asinseed_version': 'V' + chrome.runtime.getManifest().version,
            'asinseed_upgrade_tip': fIsNeedUpgrade(),
            'current_user': _user.surname,
            'footer_new_user': _cuser.surname,
            'new_login_user': _cuser.email != _user.email
        });
    $('#main-container .list-bottom').html(_f);
    $('#main-container .list-bottom [name="switch-to-new-account"]').click(function () {
        var luser = JSON.parse(localStorage.getItem('CURRENT_ASINSEED_LOGIN_USER') || '{}');
        luser && luser.token && luser.surname && localStorage.setItem('CURRENT_ASINSEED_AUTH_USER', JSON.stringify(luser));
        location.reload()
    });

    // 查看当前活跃窗口
    chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
        // 地址栏中没有ASIN，如在关键词列表页
        if (SSTool.fGetAmazonStation(tabs[0].url)) {
            var station = SSTool.fGetAmazonStation(tabs[0].url), _url = SSTool.fGetAsin(tabs[0].url) || CryptoJS.MD5(tabs[0].url).toString();
            !fHasPageAsinList(_url, station) && chrome.tabs.sendMessage(tabs[0].id, {type: "cal-asinseed-product-list"}, function (response) {
                response && response.code && response.code == 'done' && fInitSelect2(_url, station.toUpperCase());
            });
        }

        // 用户自己搜索
        $('form.head-form').unbind().submit(function () {
            var station = SSTool.fGetAmazonStation(tabs[0].url) || 'COM', asin = $('form.head-form input[name=asin]').val().replace(/[^0-9A-Za-z]/g, '');
            $('#tab_gk').html($('#id_tpl_script_gk_data_loading').html());
            fInitProductItems({
                station: station.toUpperCase(),
                asin: $.trim(asin).toUpperCase()
            });

            return false;
        });
        $('form.head-form #head-form-search').click(function () {$('form.head-form').submit()});

        if (SSTool.fGetAmazonStation(tabs[0].url) == null) {
            // 当前不在亚马逊站点
            fInitInvalidProductLink(tabs[0].url);
            return false
        }

        if (SSTool.fGetAsin(tabs[0].url) == null) {
            fInitInvalidProductLink(tabs[0].url);
        }
        if (SSTool.fGetAmazonStation(tabs[0].url) || SSTool.fGetAsin(tabs[0].url)) {
            var station = SSTool.fGetAmazonStation(tabs[0].url), asin = SSTool.fGetAsin(tabs[0].url) || CryptoJS.MD5(tabs[0].url).toString();
            $('form.head-form .flag-icon').attr('class', 'flag-icon flag-icon-' + SSTool.fGetAmazonStationFlag(tabs[0].url));
            fInitSelect2(asin, station.toUpperCase());

            if (SSTool.fIsBAsin(asin)) {
                $('form.head-form input[name=asin]').val(asin);
                $('#tab_gk').html($('#id_tpl_script_gk_data_loading').html());

                setTimeout(function () {
                    fInitProductItems({
                        station: station.toUpperCase(),
                        asin: asin
                    })
                }, 10);
            }
        }

        // 清除缓存
        setTimeout(function () {fClearResultCache()}, 10000)
    });
});

function fCallback(data) {
    data.code == 'OK' && data.station && data.asin && localStorage.setItem(fGetCachedKey(data.station, data.asin), JSON.stringify(data));

    // 设置服务最新版本号
    data.version && fIsNeedUpgrade(data.version);
    if (data.code != 'OK' && data.code.indexOf('ERR_') == 0) {
        $('#tab_gk').html(Mustache.to_html($('#id_tpl_script_gk_error_occur').html(), {'error_message': data.message,'error_code': data.code}));
        return false
    } if (data.code != 'OK') {
        $('#tab_gk').html($('#id_tpl_script_gk_empty_result').html());
        return false
    } else if (!data.count || !data.items) {
        $('#tab_gk').html($('#id_tpl_script_gk_empty_result').html());
        return false
    }

    var list = [], copied = '';
    for (var k in data.items) {
        list.push({
            'keyword': data.items[k].keyword,
            'hot': data.items[k].hot,
            'amazon': data.marketplace + '/s/field-keywords=' + data.items[k].keyword
        });
        copied += data.items[k].keyword + '\r\n';
    }

    var view = {
        'copied_text': copied,
        'gk_result_count': data.count,
        'gk_result_limit': data.limit || 20,
        'gk_list': list,
        'unlimited': list.length >= data.count,
        'limited': list.length != data.count && fGetToken() == '',
        'limited_user': list.length != data.count && fGetToken() != ''
    };
    var found  = Mustache.to_html($('#id_tpl_script_gk_found_result').html(), view);
    $('#tab_gk').html(found);
    $("[data-toggle='tooltip']").tooltip();

    var clipboard = new Clipboard('.copy-button');
    clipboard.on('success', function(e) {
        var t = $(e.trigger).attr('_title') || '';
        $(e.trigger).attr('title', t).tooltip('fixTitle').tooltip('show');
        setTimeout(new function(){$(e.trigger).attr('data-original-title', '')}, 2000);
    });
}

function fInitProductItems(_data, _callback) {
    $("[data-toggle='tooltip']").tooltip();

    try {
        var obj = localStorage.getItem(fGetCachedKey(_data.station, _data.asin));
        if (obj != null && obj != '') {
            obj = JSON.parse(obj);
            if (obj['code']) {
                fCallback(obj);
                return true
            }
        }
    } catch (e) {}

    fLoadData(_data, fCallback)
}
function fInitInvalidProductLink(_url) {
    $("[data-toggle='tooltip']").tooltip();
    $('#tab_gk').html($('#id_tpl_script_gk_not_at_amazon').html());
}

function fLoadData(_data, _callback) {
    var fd = {
            "language": chrome.i18n.getMessage('@@ui_locale'),
            "extension": chrome.i18n.getMessage('@@extension_id'),
            "version": chrome.runtime.getManifest().version,
            "token": fGetToken()
        },
        _timer = null, _K = 0;
    fGetLocalStorage(_data, fd);
    SSTool.fPostFeedback(GLOBAL_BASE_WEBSITE + '/extension/search/' + _data.station + '/' + _data.asin
        + '.json', fd, _callback);
}

function fGetLocalStorage(_data, fd) {
    var product = localStorage.getItem(_data.station + '_' + _data.asin);
    if (product != null && product != '') {
        product = JSON.parse(product);
        for (var k in product) fd[k] = product[k];

        return fd
    }

    return null
}
